// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include "KNXBasicObjectTypes.h"

extern KNXConnection* knx;







void KNXBit::print() {
	Serial.print("Value:"); 
	Serial.println(get());
	if (isCheckingStatus()) {
			Serial.print("Status confirmed:"); 
			Serial.println(getStatusBit());
		}
	Serial.print("last change:");
	Serial.println(this->lastChange);
	
}

void KNXBit::receivedFromKNX(uint16_t ga, uint8_t d) {
	// group Address = ga --> change the value of the object 
	if (ga == groupAddress) {
		if (isCheckingStatus()) { 
			if (getInternalBit()) { 
					knx->write(statusGA, d, 1);
					setStatusBit(1);
				}
			else { 
					setStatusBit(0);
			}
		}
		setDataBit((boolean)d);
		resetLastChange();
	}
	if (isCheckingStatus() && ga == statusGA) {
		setDataBit((boolean)d);
		setStatusBit(1);
	}
	
}


void KNXBit::set(uint8_t d) {
	setDataBit((bool)d);
	resetLastChange();
	if (getInternalBit()) { // Arduino is the device -> send ACK on StatusGA
		if (isCheckingStatus()) { knx->write(statusGA, d, 1); }	
	}
	else {
		knx->write(groupAddress, d, 1);
	}
}












void KNXByte::print() {
	Serial.print("Value:"); 
	Serial.println(get());
	if (isCheckingStatus()) {
			Serial.print("Status confirmed:"); 
			Serial.println(getStatusBit());
		}
	
}

void KNXByte::receivedFromKNX(uint16_t ga, uint8_t d) {
	if (ga == groupAddress) {
		if (isCheckingStatus()) { 
			if (getInternalBit()) {
					knx->write(statusGA, d, 8);
					setStatusBit(1);
				}
			else { 
					setStatusBit(0);
			}
		}
		data = d;
		resetLastChange();


	}
	if (isCheckingStatus() && ga == statusGA) {
		data = d;
		resetLastChange();
		setStatusBit(1);
	}
	
}


void KNXByte::set(uint8_t d) {
	data = d;
	resetLastChange();

	if (getInternalBit()) { // Arduino is the device -> send ACK on StatusGA
		if (isCheckingStatus()) { knx->write(statusGA, d, 8); }	
	}
	else {
		knx->write(groupAddress, d, 8);
	}
}

