// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!


#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include "KNXCommandSequence.h"
#include "KNXConnection.h" 



KNXCommandSequence:: KNXCommandSequence():KNXBit() {
	commandList = NULL;
	startTime = NULL;
	}

void KNXCommandSequence::addCommand(KNXCommand* cmd) {
	cmd->next = commandList;
	commandList = cmd;	
	}

// reset setzt alle Kommandos auf undone (für neuen Ablauf)
void KNXCommandSequence::reset() {
	
	KNXCommand *ptr = commandList;
	while(ptr != NULL) {
		ptr->reset();
		ptr = ptr->next;		
	}
}


// CommandoSequenz ausführen
// muss im Loop aufgerufen werden, damit alle Kommandos zur richtigen Zeit abgearbeitet werden.
void KNXCommandSequence::start() {
	reset();
	startTime=millis();
}

void KNXCommandSequence::set(uint8_t value) {
	KNXBit::set(value);
	if(value==1) {
		start();	
	}
	if(value==0) {
		reset();	
		startTime = NULL;		
	}
}

void KNXCommandSequence::doIt() {
	if (startTime != NULL) { 
	  uint16_t elapsed = (millis()-startTime) / 100; // in 1/10 sek.
	  KNXCommand *ptr = commandList;

	  while(ptr != NULL) {
		ptr->doIt(elapsed);
		ptr = ptr->next;		
	  }
	}
}



// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
	

KNXCommand::KNXCommand(KNXObject* obj, uint8_t val, uint16_t del) : object(obj), value(val), delayT(del) {}

void KNXCommand::reset() { done = false; }

void KNXCommand::doIt(uint16_t act) { 
	if (!done) {
		if (delayT < act) {
			object->set(value);	
			done = true;
			delay(5);
		}
	}	
}

