// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!


#ifndef KNXCommandSequence_h
#define KNXCommandSequence_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
  
#include "KNXConnection.h" 
#include "KNXBasicObjectTypes.h"


//-- Eine CommandSequence erzeut eine Abfolge von KNX Befehlen, die ev. mit Delay ausgeführt werden



// -- zum ablegen eines kommandos, die in KNXCommandSequence gespeichert werden
class KNXCommand {
	public:	
		KNXCommand(KNXObject* obj, uint8_t value, uint16_t delay);
		void doIt(uint16_t delay);
		void reset();
		KNXCommand* next;
	private:
		KNXObject *object;
		uint8_t value; // zu sendender Wert
		uint16_t delayT; //(1/10 seconds)
		boolean done;
};



class KNXCommandSequence : public KNXBit{
	public:	
		KNXCommandSequence();
		void addCommand(KNXCommand*);
		void doIt(); // loopfunktion
		void start(); // startet die kommandosequenz
		void reset(); // setzt die Kommandokette zurück (alle Command auf nicht done)
		void set(uint8_t value); // wert wird geändert -> starten !
	private:
		KNXCommand* commandList;
		uint32_t startTime; // millis als das letzte mal gestartet worden ist

};





#endif 