// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!


#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include "KNXConnection.h";

extern KNXConnection* knx;

    uint16_t gaToInt (uint8_t first, uint8_t second, uint8_t third) {return (uint16_t)first << 11 | second << 8 | third; }
	uint8_t getFirst(uint16_t ad) {return ad >> 11;}
    uint8_t getSecond(uint16_t ad) {
        	uint8_t hb = highByte(ad);
        	return hb & B00000111;
        	}
    uint8_t getThird(uint16_t ad) {return lowByte(ad);}



void KNXObject::receivedFromKNX(uint16_t ga, uint8_t value) {}


KNXObject::KNXObject() {
	groupAddress = 0;
	statusGA = 0;
	flags = 0; // set all Data Bits to 0 !
	resetLastChange();
	knx->addListeningObject(this); 
}

KNXObject::KNXObject(uint16_t ga) {
	statusGA = 0;
	flags = 0; // set all Data Bits to 0 !
	setGroupAddress(ga);
	resetLastChange();
	knx->addListeningObject(this); 
	Serial.println("Object");
	Serial.println(getGroupAddress());
}

KNXObject::KNXObject(uint16_t ga, uint16_t sa) {
	flags = 0; // set all Data Bits to 0 !
	setGroupAddress(ga);
	setStatusGA(sa);
	resetLastChange();
	knx->addListeningObject(this); 
}

boolean KNXObject::isListeningTo(uint16_t ga) {
	if (ga == 0 || groupAddress == 0) return false;
	if (ga == groupAddress) return true;
	if (statusGA == 0) return false;
	if (statusGA == ga) return true;
	return false;
}

void KNXObject::setGroupAddress(uint16_t ga) {
	groupAddress = ga;
}

void KNXObject::setStatusGA(uint16_t ga) {
	statusGA = ga;
}






KNXConnection::KNXConnection() {
	for (int i = 0; i < MaxListeningObjects; i++) {
		listeningObjects[i] = 0;
	}
	restartIterator();
}


void KNXConnection::sendDataToObject(uint16_t ga, uint8_t data) {
	int i = 0;
	while(listeningObjects[i]) { 
		//listeningObjects[i]->print();
		// Serial.println("Objekt jetzt !");
		listeningObjects[i]->receivedFromKNX(ga, data);
		i++;
	}
}




void KNXConnection::addListeningObject(KNXObject* obj) {
	uint8_t i = 0;
	while(listeningObjects[i] != NULL) { i++; }
	
	if (i >= MaxListeningObjects) {
			#if defined(KNXConnectionDebug)
				KNXConnectionDebug.println("Max. listening Objects reached.");
			#endif
		return;
	}
	listeningObjects[i]=obj;
	listeningObjects[i+1]=NULL;
}


KNXObject* KNXConnection::getObjectFromGA(uint16_t ga) {
	uint8_t i = 0;
	while(listeningObjects[i] != NULL) { 
		if (listeningObjects[i]->getGroupAddress()==ga) return listeningObjects[i];
		i++; 
	}
	return false;
}
