// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!


#ifndef KNXPresenceSimulation_h
#define KNXPresenceSimulation_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include "KNXConnection.h" 
#include "KNXBasicObjectTypes.h"


#include "elapsedMillis.h"


class KNXPresenceSimulationObj
{
	public:
		KNXPresenceSimulationObj(KNXBit*, int minOn, int maxOn, int minOff, int maxOff);
		KNXPresenceSimulationObj* next;

		void doIt();
		void toggle();	
		void off();	
	private:
		int minOnTime;
		int minOffTime;
		int maxOnTime;
		int maxOffTime;
		int actualValue;
		uint32_t delay;
		elapsedMillis elapsed;
		
		void planNextChange();
		KNXBit *object;
};



class KNXPresenceSimulation:public KNXBit {
	public:
		KNXPresenceSimulation();	
		void addObject(KNXPresenceSimulationObj *obj);
		void doIt();
	private:
		KNXPresenceSimulationObj *objectList;
		void set(uint8_t);
		void allOff();
		
}; // end class KNXPresenceSimulation



#endif //KNXPresenceSimulation_h