// ************** KNiXuino - KNX Bus and Arduino ****************
// for further info check http://www.knixuino.com
// Version info - _readme.txt
// Copyright info - _licence.txt
// Do not remove this headerinfo !!!!


#ifndef KNXWebserver_h
#define KNXWebserver_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include <stdlib.h>      

#include "SPI.h"
#include "Ethernet.h"
#include "WebServer.h"
#include "KNXConnection.h";


#define PREFIX ""
#define PORT 80

static uint8_t mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
static uint8_t ip[] = { 10, 0, 0, 140 };


void defaultCommand(WebServer &server, WebServer::ConnectionType type, char *txt, bool)
{
  server.httpSuccess();
  if (type != WebServer::HEAD)
  {
    P(helloMsg) = "<h1>KNiXuino Webserver!</h1><p>Ready to serve!</p>";
    server.printP(helloMsg);
    server.println(txt);
  }
}


// vorerst nur bit werte !
void setCommand(WebServer &server, WebServer::ConnectionType type, char *txt, bool)
{
  server.httpSuccess();
  // check post varoables 
    bool repeat;
    char name[16], value[16];
	uint16_t ga;
	uint8_t data;
	
    do
    {
      repeat = server.readPOSTparam(name, 8, value, 8);
      if (strcmp(name, "ga") == 0)
      {
        ga = strtol(value, NULL, 10);
      }
      if (strcmp(name, "val") == 0)
      {
        data = strtol(value, NULL, 10);
      }
    } while (repeat);
  
  	KNXObject* obj = knx->getObjectFromGA(ga);
  	if (!obj) { server.print("E1"); server.print(ga); return; }
  	if (!obj->getWebInBit()) { server.print("E2"); return; }
  	
  	obj->set(data);
    //knx->write(ga, data, 1); // just write to the knx . works, but has no security check if object is writeable
 	server.print(data);  // also print back the value to the webapp   
}



void updateCommand(WebServer &server, WebServer::ConnectionType type, char *txt, bool)
{
   server.httpSuccess();
   server.println("{");
   
   knx->restartIterator();
   KNXObject* obj;
   boolean first = true;
   while(obj = knx->nextObject()) {	
   		if(obj->getGroupAddress() && obj->getWebOutBit() && (obj->getLastChange() < 6000)) {
	   		if (!first) server.println(",");

   			server.print('"');	
   			server.print(obj->getGroupAddress());	
   			server.print('"');	
   			server.print(':');	
   			server.print('"');	
   			server.print(obj->get());	
   			server.print('"');	
   			
   			// falls StatusGA gegeben, ev auch Status schreiben.
   			
   			if (obj->isCheckingStatus() && obj->getStatusBit()) {
   			
   			server.println(",");
   			server.print('"');	
   			server.print(obj->getStatusGroupAddress());	
   			server.print('"');	
   			server.print(':');	
   			server.print('"');	
   			server.print(obj->get());	
   			server.print('"');	
   			}
    			
   		}
   		first = false;
   }
   
   server.println("}");
}





void allCommand(WebServer &server, WebServer::ConnectionType type, char *txt, bool)
{
   server.httpSuccess();
   server.println("{");
   
   knx->restartIterator();
   KNXObject* obj;
   boolean first = true;
   while(obj = knx->nextObject()) {	
   		if(obj->getGroupAddress() && obj->getWebOutBit()) {
	   		if (!first) server.println(",");

   			server.print('"');	
   			server.print(obj->getGroupAddress());	
   			server.print('"');	
   			server.print(':');	
   			server.print('"');	
   			server.print(obj->get());	
   			server.print('"');	
   		}
   		first = false;
   }
   
   server.println("}");
}





class KNXWebserver: public WebServer
{
		
	public:
		KNXWebserver(): WebServer(PREFIX, PORT) { };
		void setupServer();
		void doIt();
};


void KNXWebserver::setupServer() {
			  Ethernet.begin(mac, ip);
			  setDefaultCommand(&defaultCommand);
			  addCommand("set.php", &setCommand);
			  addCommand("update.php", &updateCommand);
			  addCommand("all.php", &allCommand);

			  begin();
}

void KNXWebserver::doIt() {
  	processConnection();
}



KNXWebserver* webserver = new KNXWebserver();
#endif 